summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
-rw-r--r--tests/expected/kill/queue1
-rw-r--r--tests/helpers/test_sigreceive.c17
-rwxr-xr-xtests/ts/kill/options2
-rwxr-xr-xtests/ts/kill/queue53
4 files changed, 66 insertions, 7 deletions
diff --git a/tests/expected/kill/queue b/tests/expected/kill/queue
new file mode 100644
index 000000000..d48ce7299
--- /dev/null
+++ b/tests/expected/kill/queue
@@ -0,0 +1 @@
+all ok
diff --git a/tests/helpers/test_sigreceive.c b/tests/helpers/test_sigreceive.c
index 3f76f0671..f1b954688 100644
--- a/tests/helpers/test_sigreceive.c
+++ b/tests/helpers/test_sigreceive.c
@@ -38,9 +38,16 @@ static void __attribute__((__noreturn__)) usage(FILE *out)
}
static __attribute__((__noreturn__))
-void exiter(int sig)
+void exiter(int signo __attribute__((__unused__)),
+ siginfo_t *info,
+ void *context __attribute__((__unused__)))
{
- _exit(sig);
+ int ret = info->si_signo;
+
+ if (info)
+ if (info->si_code == SI_QUEUE && info->si_value.sival_int != 0)
+ ret = info->si_value.sival_int;
+ _exit(ret);
}
int main(int argc, char **argv)
@@ -81,8 +88,8 @@ int main(int argc, char **argv)
}
sigemptyset(&sigact.sa_mask);
- sigact.sa_flags = 0;
- sigact.sa_handler = exiter;
+ sigact.sa_flags = SA_SIGINFO;
+ sigact.sa_sigaction = exiter;
timeout.tv_sec = 5;
timeout.tv_usec = 0;
@@ -171,5 +178,5 @@ int main(int argc, char **argv)
FD_SET(STDIN_FILENO, &rfds);
select(0, &rfds, NULL, NULL, &timeout);
- exiter(TEST_SIGRECEIVE_FAILURE);
+ exit(TEST_SIGRECEIVE_FAILURE);
}
diff --git a/tests/ts/kill/options b/tests/ts/kill/options
index 5af78d969..2c82bbccc 100755
--- a/tests/ts/kill/options
+++ b/tests/ts/kill/options
@@ -51,8 +51,6 @@ try_option -s 1
try_option --signal 1
try_option --signal HUP
try_option --signal SIGHUP
-try_option -s 1 -q 42
-try_option -s 1 --queue 42
try_option -1
try_option -HUP
try_option -SIGHUP
diff --git a/tests/ts/kill/queue b/tests/ts/kill/queue
new file mode 100755
index 000000000..992acf7a6
--- /dev/null
+++ b/tests/ts/kill/queue
@@ -0,0 +1,53 @@
+#!/bin/bash
+
+# This file is part of util-linux.
+#
+# This file is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This file is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+TS_TOPDIR="${0%/*}/../.."
+TS_DESC="queue"
+
+. "$TS_TOPDIR/functions.sh"
+ts_init "$*"
+
+ts_check_test_command "$TS_CMD_KILL"
+ts_check_test_command "$TS_HELPER_SIGRECEIVE"
+
+. "$TS_SELF/kill_functions.sh"
+
+all_ok=true
+
+HELPER_SYMLINK="$(mktemp "${TS_OUTDIR}/quXXXXXXXXXXXXX")"
+ln -sf "$TS_HELPER_SIGRECEIVE" "$HELPER_SYMLINK"
+
+"$HELPER_SYMLINK" >> "$TS_OUTPUT" 2>&1 &
+TEST_PID=$!
+check_test_sigreceive $TEST_PID
+[ $? -eq 1 ] || echo "${HELPER_SYMLINK##*/} helper did not start" >> "$TS_OUTPUT"
+
+"$TS_CMD_KILL" -1 --queue 42 $TEST_PID >> "$TS_OUTPUT" 2>&1
+if [ $? -ne 0 ]; then
+ echo "kill --queue 42 failed" >> "$TS_OUTPUT"
+ all_ok=false
+fi
+wait $TEST_PID
+if [ $? -ne 42 ]; then
+ echo "wait $TEST_PID returned $? instead of 42" >> "$TS_OUTPUT"
+ all_ok=false
+fi
+
+if $all_ok; then
+ echo 'all ok' >> "$TS_OUTPUT"
+fi
+
+rm -f "$HELPER_SYMLINK"
+
+ts_finalize